Index: main/plugin-survey/src/org/ametys/plugins/survey/actions/CreateSurveyAction.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/actions/CreateSurveyAction.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/actions/CreateSurveyAction.java	(working copy)
@@ -18,17 +18,26 @@
 import java.util.HashMap;
 import java.util.Map;
 
+import org.apache.avalon.framework.context.ContextException;
+import org.apache.avalon.framework.context.Contextualizable;
 import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.Constants;
+import org.apache.cocoon.environment.Context;
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Redirector;
 import org.apache.cocoon.environment.Request;
 import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.lang.StringUtils;
 
 import org.ametys.cms.FilterNameHelper;
 import org.ametys.cms.observation.Event;
 import org.ametys.plugins.repository.ModifiableTraversableAmetysObject;
 import org.ametys.plugins.survey.SurveyEvents;
 import org.ametys.plugins.survey.repository.Survey;
+import org.ametys.runtime.upload.Upload;
+import org.ametys.runtime.upload.UploadManager;
 
 /** 
  * This class creates a new survey
@@ -52,6 +61,9 @@
         String endingMessage = request.getParameter("endingMessage");
         String isPrivate = request.getParameter("private");
         String originalName = FilterNameHelper.filterName(label);
+        String pictureId = request.getParameter("picture");
+        String pictureType = request.getParameter("picture#type");
+        String pictureAlternative = request.getParameter("picture-alternative");
         
         ModifiableTraversableAmetysObject rootNode = getSurveyRootNode(siteName, lang);
         
@@ -70,6 +82,28 @@
         survey.setEndingMessage(endingMessage);
         survey.setPrivate("true".equals(isPrivate));
         
+        if (StringUtils.isEmpty(pictureId))
+        {
+            // Deletion.
+            survey.setNoPicture();
+        }
+        else if (pictureType.equals("resource"))
+        {
+            survey.setResourcePicture(pictureId);
+        }
+        else if (pictureType.equals("external"))
+        {
+            String login = _getCurrentUser();
+            Upload upload = _uploadManager.getUpload(login, pictureId);
+            
+            String filename = upload.getFilename();
+            String mimeType = upload.getMimeType() != null ? upload.getMimeType() : _context.getMimeType(filename);
+            String finalMimeType = mimeType != null ? mimeType : "application/unknown";
+            
+            survey.setExternalPicture(finalMimeType, filename, upload.getInputStream());
+        }
+        survey.setPictureAlternative(pictureAlternative);
+        
         result.put("id", survey.getId());
         
         rootNode.saveChanges();
Index: main/plugin-survey/src/org/ametys/plugins/survey/actions/UpdatePageAction.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/actions/UpdatePageAction.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/actions/UpdatePageAction.java	(working copy)
@@ -18,15 +18,24 @@
 import java.util.HashMap;
 import java.util.Map;
 
+import org.apache.avalon.framework.context.ContextException;
+import org.apache.avalon.framework.context.Contextualizable;
 import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.Constants;
+import org.apache.cocoon.environment.Context;
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Redirector;
 import org.apache.cocoon.environment.Request;
 import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.lang.StringUtils;
 
 import org.ametys.cms.observation.Event;
 import org.ametys.plugins.survey.SurveyEvents;
 import org.ametys.plugins.survey.repository.SurveyPage;
+import org.ametys.runtime.upload.Upload;
+import org.ametys.runtime.upload.UploadManager;
 
 /**
  * Edit a page survey
@@ -46,12 +55,40 @@
         String label = request.getParameter("label");
         String title = request.getParameter("title");
         String description = request.getParameter("description");
+        String pictureId = request.getParameter("picture");
+        String pictureType = request.getParameter("picture#type");
+        String pictureAlternative = request.getParameter("picture-alternative");
         
         SurveyPage page = _resolver.resolveById(pageId);
         page.setTitle(title);
         page.setLabel(label);
         page.setDescription(description);
         
+        if (StringUtils.isEmpty(pictureId))
+        {
+            page.setNoPicture();
+        }
+        else if (pictureId.equals("untouched"))
+        {
+            // Do nothing.
+        }
+        else if (pictureType.equals("resource"))
+        {
+            page.setResourcePicture(pictureId);
+        }
+        else if (pictureType.equals("external"))
+        {
+            String login = _getCurrentUser();
+            Upload upload = _uploadManager.getUpload(login, pictureId);
+            
+            String filename = upload.getFilename();
+            String mimeType = upload.getMimeType() != null ? upload.getMimeType() : _context.getMimeType(filename);
+            String finalMimeType = mimeType != null ? mimeType : "application/unknown";
+            
+            page.setExternalPicture(finalMimeType, filename, upload.getInputStream());
+        }
+        page.setPictureAlternative(pictureAlternative);
+        
         page.saveChanges();
         
         _observationManager.notify(new Event(_getCurrentUser(), SurveyEvents.SURVEY_MODIFIED, page.getSurvey()));
Index: main/plugin-survey/src/org/ametys/plugins/survey/actions/UpdateQuestionAction.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/actions/UpdateQuestionAction.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/actions/UpdateQuestionAction.java	(working copy)
@@ -31,6 +31,7 @@
 import org.ametys.plugins.survey.SurveyEvents;
 import org.ametys.plugins.survey.repository.SurveyQuestion;
 import org.ametys.plugins.survey.repository.SurveyQuestion.QuestionType;
+import org.ametys.runtime.upload.Upload;
 
 /** 
  * This class creates a new question
@@ -56,6 +57,9 @@
         String options = request.getParameter("options");
         String columns = request.getParameter("columns");
         boolean otherOption = "true".equals(request.getParameter("other-option"));
+        String pictureId = request.getParameter("picture");
+        String pictureType = request.getParameter("picture#type");
+        String pictureAlternative = request.getParameter("picture-alternative");
         
         question.setLabel(label);
         question.setTitle(title);
@@ -63,6 +67,31 @@
         question.setType(QuestionType.valueOf(type));
         question.setRegExpType(regexp);
         
+        if (StringUtils.isEmpty(pictureId))
+        {
+            question.setNoPicture();
+        }
+        else if (pictureId.equals("untouched"))
+        {
+            // Do nothing.
+        }
+        else if (pictureType.equals("resource"))
+        {
+            question.setResourcePicture(pictureId);
+        }
+        else if (pictureType.equals("external"))
+        {
+            String login = _getCurrentUser();
+            Upload upload = _uploadManager.getUpload(login, pictureId);
+            
+            String filename = upload.getFilename();
+            String mimeType = upload.getMimeType() != null ? upload.getMimeType() : _context.getMimeType(filename);
+            String finalMimeType = mimeType != null ? mimeType : "application/unknown";
+            
+            question.setExternalPicture(finalMimeType, filename, upload.getInputStream());
+        }
+        question.setPictureAlternative(pictureAlternative);
+        
         if (StringUtils.isNotEmpty(options))
         {
             Map<String, String> opts = new LinkedHashMap<String, String>();
Index: main/plugin-survey/src/org/ametys/plugins/survey/actions/UpdateSurveyAction.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/actions/UpdateSurveyAction.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/actions/UpdateSurveyAction.java	(working copy)
@@ -18,15 +18,24 @@
 import java.util.HashMap;
 import java.util.Map;
 
+import org.apache.avalon.framework.context.ContextException;
+import org.apache.avalon.framework.context.Contextualizable;
 import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.Constants;
+import org.apache.cocoon.environment.Context;
 import org.apache.cocoon.environment.ObjectModelHelper;
 import org.apache.cocoon.environment.Redirector;
 import org.apache.cocoon.environment.Request;
 import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.lang.StringUtils;
 
 import org.ametys.cms.observation.Event;
 import org.ametys.plugins.survey.SurveyEvents;
 import org.ametys.plugins.survey.repository.Survey;
+import org.ametys.runtime.upload.Upload;
+import org.ametys.runtime.upload.UploadManager;
 
 /** 
  * This class edits a survey
@@ -48,6 +57,9 @@
         String description = request.getParameter("description");
         String endingMessage = request.getParameter("endingMessage");
         String isPrivate = request.getParameter("private");
+        String pictureId = request.getParameter("picture");
+        String pictureType = request.getParameter("picture#type");
+        String pictureAlternative = request.getParameter("picture-alternative");
         
         Survey survey = _resolver.resolveById(surveyId);
         survey.setTitle(title);
@@ -56,6 +68,31 @@
         survey.setEndingMessage(endingMessage);
         survey.setPrivate("true".equals(isPrivate));
         
+        if (StringUtils.isEmpty(pictureId))
+        {
+            survey.setNoPicture();
+        }
+        else if (pictureId.equals("untouched"))
+        {
+            // Do nothing.
+        }
+        else if (pictureType.equals("resource"))
+        {
+            survey.setResourcePicture(pictureId);
+        }
+        else if (pictureType.equals("external"))
+        {
+            String login = _getCurrentUser();
+            Upload upload = _uploadManager.getUpload(login, pictureId);
+            
+            String filename = upload.getFilename();
+            String mimeType = upload.getMimeType() != null ? upload.getMimeType() : _context.getMimeType(filename);
+            String finalMimeType = mimeType != null ? mimeType : "application/unknown";
+            
+            survey.setExternalPicture(finalMimeType, filename, upload.getInputStream());
+        }
+        survey.setPictureAlternative(pictureAlternative);
+        
         survey.saveChanges();
         
         _observationManager.notify(new Event(_getCurrentUser(), SurveyEvents.SURVEY_MODIFIED, survey));
Index: main/plugin-survey/src/org/ametys/plugins/survey/generators/SurveyGenerator.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/generators/SurveyGenerator.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/generators/SurveyGenerator.java	(working copy)
@@ -27,9 +27,13 @@
 import org.apache.cocoon.environment.Request;
 import org.apache.cocoon.xml.AttributesImpl;
 import org.apache.cocoon.xml.XMLUtils;
+import org.apache.commons.lang.StringUtils;
 import org.xml.sax.SAXException;
 
+import org.ametys.plugins.explorer.resources.Resource;
 import org.ametys.plugins.repository.AmetysObjectIterable;
+import org.ametys.plugins.repository.UnknownAmetysObjectException;
+import org.ametys.plugins.repository.metadata.BinaryMetadata;
 import org.ametys.plugins.survey.data.SurveyAnswerDao;
 import org.ametys.plugins.survey.repository.Survey;
 import org.ametys.plugins.survey.repository.SurveyPage;
@@ -88,6 +92,37 @@
         XMLUtils.createElement(contentHandler, "title", survey.getTitle());
         XMLUtils.createElement(contentHandler, "label", survey.getLabel());
         
+        AttributesImpl attrsPicture = new AttributesImpl();
+        String pictureType = survey.getPictureType();
+        attrsPicture.addCDATAAttribute("pictureType", pictureType);
+        if (pictureType.equals("resource"))
+        {
+            String resourceId = survey.getResourcePictureId();
+            attrsPicture.addCDATAAttribute("pictureId", resourceId);
+            try
+            {
+                Resource resource = _resolver.resolveById(resourceId);
+                attrsPicture.addCDATAAttribute("pictureName", resource.getName());
+                attrsPicture.addCDATAAttribute("pictureSize", Long.toString(resource.getLength()));
+                attrsPicture.addCDATAAttribute("imageType", "explorer");
+            }
+            catch (UnknownAmetysObjectException e)
+            {
+                getLogger().error("The resource of id'" + resourceId + "' does not exist anymore. The picture for survey of id '" + survey.getId() + "' will be ignored.", e);
+            }
+            
+        }
+        else if (pictureType.equals("external"))
+        {
+            BinaryMetadata picMeta = survey.getExternalPicture();
+            attrsPicture.addCDATAAttribute("picturePath", "picture");
+            attrsPicture.addCDATAAttribute("pictureName", picMeta.getFilename());
+            attrsPicture.addCDATAAttribute("pictureSize", Long.toString(picMeta.getLength()));
+            attrsPicture.addCDATAAttribute("imageType", "metadata");
+        }
+        XMLUtils.createElement(contentHandler, "picture", attrsPicture);
+        XMLUtils.createElement(contentHandler, "pictureAlternative", StringUtils.defaultString(survey.getPictureAlternative()));
+        
         if (startDate != null)
         {
             XMLUtils.createElement(contentHandler, "startDate", ParameterHelper.valueToString(startDate));
Index: main/plugin-survey/src/org/ametys/plugins/survey/generators/SurveysGenerator.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/generators/SurveysGenerator.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/generators/SurveysGenerator.java	(working copy)
@@ -32,11 +32,14 @@
 import org.apache.commons.lang.StringUtils;
 import org.xml.sax.SAXException;
 
+import org.ametys.plugins.explorer.resources.Resource;
 import org.ametys.plugins.repository.AmetysObject;
 import org.ametys.plugins.repository.AmetysObjectIterable;
 import org.ametys.plugins.repository.AmetysObjectResolver;
 import org.ametys.plugins.repository.ModifiableTraversableAmetysObject;
+import org.ametys.plugins.repository.UnknownAmetysObjectException;
 import org.ametys.plugins.repository.jcr.JCRAmetysObject;
+import org.ametys.plugins.repository.metadata.BinaryMetadata;
 import org.ametys.plugins.survey.repository.Survey;
 import org.ametys.plugins.survey.repository.SurveyPage;
 import org.ametys.plugins.survey.repository.SurveyQuestion;
@@ -135,6 +138,37 @@
         XMLUtils.createElement(contentHandler, "title", survey.getTitle());
         XMLUtils.createElement(contentHandler, "label", survey.getLabel());
         
+        AttributesImpl attrsPicture = new AttributesImpl();
+        String pictureType = survey.getPictureType();
+        attrsPicture.addCDATAAttribute("pictureType", pictureType);
+        if (pictureType.equals("resource"))
+        {
+            String resourceId = survey.getResourcePictureId();
+            attrsPicture.addCDATAAttribute("pictureId", resourceId);
+            try
+            {
+                Resource resource = _resolver.resolveById(resourceId);
+                attrsPicture.addCDATAAttribute("pictureName", resource.getName());
+                attrsPicture.addCDATAAttribute("pictureSize", Long.toString(resource.getLength()));
+                attrsPicture.addCDATAAttribute("imageType", "explorer");
+            }
+            catch (UnknownAmetysObjectException e)
+            {
+                getLogger().error("The resource of id'" + resourceId + "' does not exist anymore. The picture for survey of id '" + survey.getId() + "' will be ignored.", e);
+            }
+            
+        }
+        else if (pictureType.equals("external"))
+        {
+            BinaryMetadata picMeta = survey.getExternalPicture();
+            attrsPicture.addCDATAAttribute("picturePath", "picture");
+            attrsPicture.addCDATAAttribute("pictureName", picMeta.getFilename());
+            attrsPicture.addCDATAAttribute("pictureSize", Long.toString(picMeta.getLength()));
+            attrsPicture.addCDATAAttribute("imageType", "metadata");
+        }
+        XMLUtils.createElement(contentHandler, "picture", attrsPicture);
+        XMLUtils.createElement(contentHandler, "pictureAlternative", StringUtils.defaultString(survey.getPictureAlternative()));
+        
         String description = survey.getDescription();
         if (description != null)
         {
@@ -177,6 +211,37 @@
         XMLUtils.createElement(contentHandler, "label", page.getLabel());
         XMLUtils.createElement(contentHandler, "description", page.getDescription());
         
+        AttributesImpl attrsPicture = new AttributesImpl();
+        String pictureType = page.getPictureType();
+        attrsPicture.addCDATAAttribute("pictureType", pictureType);
+        if (pictureType.equals("resource"))
+        {
+            String resourceId = page.getResourcePictureId();
+            attrsPicture.addCDATAAttribute("pictureId", resourceId);
+            try
+            {
+                Resource resource = _resolver.resolveById(resourceId);
+                attrsPicture.addCDATAAttribute("pictureName", resource.getName());
+                attrsPicture.addCDATAAttribute("pictureSize", Long.toString(resource.getLength()));
+                attrsPicture.addCDATAAttribute("imageType", "explorer");
+            }
+            catch (UnknownAmetysObjectException e)
+            {
+                getLogger().error("The resource of id'" + resourceId + "' does not exist anymore. The picture for page survey of id '" + page.getId() + "' will be ignored.", e);
+            }
+            
+        }
+        else if (pictureType.equals("external"))
+        {
+            BinaryMetadata picMeta = page.getExternalPicture();
+            attrsPicture.addCDATAAttribute("picturePath", "picture");
+            attrsPicture.addCDATAAttribute("pictureName", picMeta.getFilename());
+            attrsPicture.addCDATAAttribute("pictureSize", Long.toString(picMeta.getLength()));
+            attrsPicture.addCDATAAttribute("imageType", "metadata");
+        }
+        XMLUtils.createElement(contentHandler, "picture", attrsPicture);
+        XMLUtils.createElement(contentHandler, "pictureAlternative", StringUtils.defaultString(page.getPictureAlternative()));
+        
         if (saxChildren)
         {
             AmetysObjectIterable<SurveyQuestion> questions = page.getChildren();
@@ -258,6 +323,37 @@
         XMLUtils.createElement(contentHandler, "label", question.getLabel());
         XMLUtils.createElement(contentHandler, "title", question.getTitle());
         
+        AttributesImpl attrsPicture = new AttributesImpl();
+        String pictureType = question.getPictureType();
+        attrsPicture.addCDATAAttribute("pictureType", pictureType);
+        if (pictureType.equals("resource"))
+        {
+            String resourceId = question.getResourcePictureId();
+            attrsPicture.addCDATAAttribute("pictureId", resourceId);
+            try
+            {
+                Resource resource = _resolver.resolveById(resourceId);
+                attrsPicture.addCDATAAttribute("pictureName", resource.getName());
+                attrsPicture.addCDATAAttribute("pictureSize", Long.toString(resource.getLength()));
+                attrsPicture.addCDATAAttribute("imageType", "explorer");
+            }
+            catch (UnknownAmetysObjectException e)
+            {
+                getLogger().error("The resource of id'" + resourceId + "' does not exist anymore. The picture for question survey of id '" + question.getId() + "' will be ignored.", e);
+            }
+            
+        }
+        else if (pictureType.equals("external"))
+        {
+            BinaryMetadata picMeta = question.getExternalPicture();
+            attrsPicture.addCDATAAttribute("picturePath", "picture");
+            attrsPicture.addCDATAAttribute("pictureName", picMeta.getFilename());
+            attrsPicture.addCDATAAttribute("pictureSize", Long.toString(picMeta.getLength()));
+            attrsPicture.addCDATAAttribute("imageType", "metadata");
+        }
+        XMLUtils.createElement(contentHandler, "picture", attrsPicture);
+        XMLUtils.createElement(contentHandler, "pictureAlternative", StringUtils.defaultString(question.getPictureAlternative()));
+        
         String regExpType = question.getRegExpType();
         if (StringUtils.isNotEmpty(regExpType))
         {
Index: main/plugin-survey/src/org/ametys/plugins/survey/repository/Survey.java
===================================================================
--- main/plugin-survey/src/org/ametys/plugins/survey/repository/Survey.java	(revision 45795)
+++ main/plugin-survey/src/org/ametys/plugins/survey/repository/Survey.java	(working copy)
@@ -15,6 +15,7 @@
  */
 package org.ametys.plugins.survey.repository;
 
+import java.io.InputStream;
 import java.util.ArrayList;
 import java.util.Collection;
 import java.util.Date;
@@ -28,6 +29,8 @@
 import javax.jcr.RepositoryException;
 import javax.jcr.Value;
 
+import org.apache.commons.lang.StringUtils;
+
 import org.ametys.plugins.repository.AmetysObject;
 import org.ametys.plugins.repository.AmetysObjectIterable;
 import org.ametys.plugins.repository.AmetysRepositoryException;
@@ -36,6 +39,10 @@
 import org.ametys.plugins.repository.ModifiableTraversableAmetysObject;
 import org.ametys.plugins.repository.RepositoryConstants;
 import org.ametys.plugins.repository.jcr.DefaultTraversableAmetysObject;
+import org.ametys.plugins.repository.metadata.BinaryMetadata;
+import org.ametys.plugins.repository.metadata.ModifiableBinaryMetadata;
+import org.ametys.plugins.repository.metadata.ModifiableCompositeMetadata;
+import org.ametys.runtime.upload.Upload;
 import org.ametys.web.repository.SiteAwareAmetysObject;
 import org.ametys.web.repository.site.Site;
 
@@ -68,6 +75,14 @@
     private static final String __GRANTED_USERS = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":grantedUsers";
     /** Constants for granted users metadata. */
     private static final String __GRANTED_GROUPS = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":grantedGroups";
+    /** Constant for picture type metadata. */
+    private static final String __METADATA_PICTURE_TYPE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-type";
+    /** Constant for picture data metadata. */
+    private static final String __METADATA_PICTURE = "picture";
+    /** Constant for picture id metadata. */
+    private static final String __METADATA_PICTURE_ID = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-id";
+    /** Constant for picture alternative metadata. */
+    private static final String __METADATA_PICTURE_ALTERNATIVE = RepositoryConstants.NAMESPACE_PREFIX_INTERNAL + ":picture-alternative";
     
     /**
      * Creates a {@link Survey}.
@@ -684,6 +699,192 @@
     }
     
     /**
+     * Get the picture as a binary metadata.
+     * @return the picture as a binary metadata.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public BinaryMetadata getExternalPicture() throws AmetysRepositoryException
+    {
+        return getMetadataHolder().getBinaryMetadata(__METADATA_PICTURE);
+    }
+    
+    /**
+     * Set the picture from an external file.
+     * @param mimeType the file MIME type.
+     * @param filename the file name.
+     * @param stream an input stream on the file bytes.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setExternalPicture(String mimeType, String filename, InputStream stream) throws AmetysRepositoryException
+    {
+        try
+        {
+            removePictureMetas();
+            
+            setPictureType("external");
+            
+            ModifiableCompositeMetadata meta = getMetadataHolder();
+            ModifiableBinaryMetadata pic = meta.getBinaryMetadata(__METADATA_PICTURE, true);
+            
+            pic.setLastModified(new Date());
+            pic.setInputStream(stream);
+            pic.setMimeType(mimeType);
+            pic.setFilename(filename);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the external picture property.", e);
+        }
+    }
+    
+    /**
+     * Get the picture resource ID.
+     * @return the resource ID.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public String getResourcePictureId() throws AmetysRepositoryException
+    {
+        try
+        {
+            return getNode().getProperty(__METADATA_PICTURE_ID).getString();
+        }
+        catch (PathNotFoundException e)
+        {
+            return null;
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error getting the picture ID property.", e);
+        }
+    }
+        
+    /**
+     * Set the picture from an explorer resource.
+     * @param resourceId the resource ID.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setResourcePicture(String resourceId) throws AmetysRepositoryException
+    {
+        try
+        {
+            removePictureMetas();
+            
+            setPictureType("resource");
+            
+            getNode().setProperty(__METADATA_PICTURE_ID, resourceId);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the alternative property.", e);
+        }
+    }
+    
+    /**
+     * Removes any picture currently assigned.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setNoPicture() throws AmetysRepositoryException
+    {
+        try
+        {
+            setPictureType("");
+            
+            removePictureMetas();
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the alternative property.", e);
+        }
+    }
+
+    /**
+     * Get the picture type.
+     * @return the picture type.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public String getPictureType() throws AmetysRepositoryException
+    {
+        try
+        {
+            return getNode().getProperty(__METADATA_PICTURE_TYPE).getString();
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error getting the type property.", e);
+        }
+    }
+    
+    /**
+     * Set the picture type.
+     * @param type the picture type to set.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setPictureType(String type) throws AmetysRepositoryException
+    {
+        try
+        {
+            getNode().setProperty(__METADATA_PICTURE_TYPE, type);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the type property.", e);
+        }
+    }
+    
+    /**
+     * Get the picture alternative.
+     * @return the picture alternative.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public String getPictureAlternative() throws AmetysRepositoryException
+    {
+        try
+        {
+            return getNode().getProperty(__METADATA_PICTURE_ALTERNATIVE).getString();
+        }
+        catch (PathNotFoundException e)
+        {
+            return null;
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error getting the alternative property.", e);
+        }
+    }
+    
+    /**
+     * Set the picture alternative.
+     * @param alternative the picture alternative to set.
+     * @throws AmetysRepositoryException if an error occurs.
+     */
+    public void setPictureAlternative(String alternative) throws AmetysRepositoryException
+    {
+        try
+        {
+            getNode().setProperty(__METADATA_PICTURE_ALTERNATIVE, alternative);
+        }
+        catch (RepositoryException e)
+        {
+            throw new AmetysRepositoryException("Error setting the alternative property.", e);
+        }
+    }
+    
+    /**
+     * Remove all picture metas (picture ID and picture binary).
+     * @throws RepositoryException if an error occurs.
+     */
+    protected void removePictureMetas() throws RepositoryException
+    {
+        getNode().setProperty(__METADATA_PICTURE_ID, "");
+        
+        ModifiableCompositeMetadata meta = getMetadataHolder();
+        if (meta.hasMetadata(__METADATA_PICTURE))
+        {
+            meta.removeMetadata(__METADATA_PICTURE);
+        }
+    }
+    
+    /**
      * Returns a unique question name in the survey
      * @param originalName The original name
      * @return a unique question name
@@ -732,6 +933,35 @@
             survey.setEndingMessage(endingMessage);
         }
         
+        String pictureType = getPictureType();
+        if (StringUtils.isBlank(pictureType))
+        {
+            survey.setNoPicture();
+        }
+        else if (pictureType.equals("resource"))
+        {
+            String pictureId = getResourcePictureId();
+            if (StringUtils.isNotBlank(pictureId))
+            {
+                survey.setResourcePicture(pictureId);
+            }
+            else
+            {
+                survey.setNoPicture();
+            }
+        }
+        else if (pictureType.equals("external"))
+        {
+            BinaryMetadata externalPicture = getExternalPicture();
+            survey.setExternalPicture(externalPicture.getMimeType(), externalPicture.getFilename(), externalPicture.getInputStream());
+        }
+        
+        String pictureAlternative = getPictureAlternative();
+        if (pictureAlternative != null)
+        {
+            survey.setPictureAlternative(pictureAlternative);
+        }
+        
         survey.setPrivate(isPrivate());
         survey.setGrantedGroups(getGrantedGroups());
         survey.setGrantedUsers(getGrantedUsers());
